yggdrasil_ng/yggdrasil.sh

292 lines
6.9 KiB
Bash
Raw Normal View History

2017-12-27 13:54:15 +00:00
#!/bin/bash
#------------------------------------------------------------------------------#
# Yggdrasil NG #
# compatibility : Mint 18, Ubuntu 16.04, Elementary and other derivatives #
# author : Francois B. (Makotosan/Shakasan) #
# licence : GPLv3 #
2018-01-23 17:50:18 +00:00
# website : https://makotonoblog.be/ #
2017-12-27 13:54:15 +00:00
#------------------------------------------------------------------------------#
#
2017-12-30 22:08:45 +00:00
# include functions and vars from external files
2017-12-27 13:54:15 +00:00
#
dir=$(dirname $0)
if [ ! $dir == "/opt/yggdrasil" ]; then
source /opt/yggdrasil/vars.sh
source /opt/yggdrasil/core_functions.sh
source /opt/yggdrasil/repo_functions.sh
source /opt/yggdrasil/install_functions.sh
source /opt/yggdrasil/menus_functions.sh
source /opt/yggdrasil/tools_functions.sh
else
source $(dirname $0)/vars.sh
source $(dirname $0)/core_functions.sh
source $(dirname $0)/repo_functions.sh
source $(dirname $0)/install_functions.sh
source $(dirname $0)/menus_functions.sh
source $(dirname $0)/tools_functions.sh
fi
2017-12-27 13:54:15 +00:00
#
2017-12-30 22:08:45 +00:00
# check if the script is running in root/sudo
2017-12-29 10:46:53 +00:00
# NEVER run the script as root or with sudo !!!!
2017-12-30 22:08:45 +00:00
#
2017-12-29 10:46:53 +00:00
if ! [ "$UID" -ne "0" ]; then
printf "\n"
2018-03-22 10:36:39 +00:00
printf $BOLDROUGE"Yggdrasil can't be run as root/sudo, please retry as normal user"$NORMAL
2017-12-29 10:46:53 +00:00
printf "\n\n"
exit
fi
2017-12-27 13:54:15 +00:00
2017-12-30 22:08:45 +00:00
#
2017-12-27 13:54:15 +00:00
# add a mark to the log file at every script run
2017-12-30 22:08:45 +00:00
#
2017-12-29 15:43:47 +00:00
echo "--[ Yggdrasil log ]--[ "$cDate" ]--[ "$cTime" ]-----------------------" >> $logFile
2017-12-27 13:54:15 +00:00
2017-12-30 22:08:45 +00:00
#-----------------------------------------------------------------------------#
# Headless Mode #
#-----------------------------------------------------------------------------#
2017-12-29 10:46:53 +00:00
#
# arguments/options management with getopts
#
while getopts ":h,v,f,c,t,u,a,d,k,s,t,n" option; do
2017-12-29 10:46:53 +00:00
case "$option" in
2018-01-01 15:58:02 +00:00
t) #test purpose only
#yggInit
2018-03-04 22:57:31 +00:00
#installIdea
#installNetTools
2018-03-14 18:53:53 +00:00
#installOffice
#addPPA "tmsu/ppa"
2018-01-01 15:58:02 +00:00
exit
;;
a) # install all apps
2018-03-24 16:09:11 +00:00
# except
# apps : Nitrogen, Beta apps, Nightly, Unboud
# hw : solaar, cardreader, fixWirelessIntel6320, nvidia drivers
# tlp, KeyID
# dev apps : all
# customization : themes, icons
2018-03-14 18:34:00 +00:00
yggInit
2018-01-05 06:38:36 +00:00
updateSystem
2018-01-05 06:14:58 +00:00
addRequiredPPA
2017-12-30 21:47:59 +00:00
installBase
2018-03-21 07:41:43 +00:00
installOffice
2017-12-30 21:47:59 +00:00
installBurningTools
installCajaPlugins
2018-03-21 07:41:43 +00:00
installNautilusAndPlugins
2017-12-30 21:47:59 +00:00
installEbook
installGames
installGimpPlugins
installInternet
installJava9
installMiscUtilities
installMultimedia
installNetTools
installOffice
installPidginPlugins
installRhythmBoxPlugins
installWine
2018-03-21 07:14:10 +00:00
installViber
installFranz
installTeamViewer13
installWebcam
updateMicrocode
enableUFW
enableNumLockX
addScreenfetchBashrc
enableHistoryTS
installUnattendedUpgrades
f) # full install
# except
# apps : Nitrogen, Beta apps, Nightly, Unboud
# hw : solaar, cardreader, fixWirelessIntel6320, nvidia drivers
# tlp, KeyID
# tweak : /tmp in ram
#TODO: dev apps
yggInit
updateSystem
addRequiredPPA
installBase
installOffice
installBurningTools
installCajaPlugins
installNautilusAndPlugins
installEbook
installGames
installGimpPlugins
installInternet
installJava9
installMiscUtilities
installMultimedia
installNetTools
installOffice
installPidginPlugins
installRhythmBoxPlugins
installWine
installViber
installFranz
installTeamViewer13
installWebcam
updateMicrocode
enableUFW
enableNumLockX
addScreenfetchBashrc
enableHistoryTS
installUnattendedUpgrades
installIcons
installThemes
2017-12-29 10:46:53 +00:00
exit
;;
c) # install themes and icons
2018-03-14 18:34:00 +00:00
yggInit
updateSystem
addRequiredPPA
2017-12-30 21:47:59 +00:00
installIcons
installThemes
2017-12-29 10:46:53 +00:00
exit
;;
d) # install Unbound DNS Cache
yggInit
updateSystem
enableUnbound
exit
;;
k) # cardreader
yggInit
updateSystem
installCardReader
exit
;;
s) # solaar for logitech devices
yggInit
updateSystem
installSolaar
exit
;;
t) # tlp (laptop or low energy usage)
yggInit
updateSystem
installTLP
exit
;;
n) # latest nvidia driver (see menus if need older version)
yggInit
updateSystem
installNvidia384
exit
;;
2018-01-03 21:59:50 +00:00
u)
2018-03-14 18:34:00 +00:00
yggInit
2018-01-03 21:59:50 +00:00
updateSystem
exit
;;
2017-12-29 10:46:53 +00:00
h) # display help
usage
exit
;;
v) # display version number
printf "Yggdrasil version : $version\n"
exit
;;
:) # display error message in case of missing argument(s)
usage
printf "\nError : Option $OPTARG : missing argument\n"
exit 1
;;
\?) # display error message in case of invalid option
usage
printf "\nError : $OPTARG : invalid option\n"
exit 1
;;
esac
done
2017-12-30 22:08:45 +00:00
#-----------------------------------------------------------------------------#
# Menu Mode #
#-----------------------------------------------------------------------------#
2017-12-29 10:46:53 +00:00
2018-03-22 10:14:26 +00:00
# show Yggdrasil logo
2017-12-30 21:12:24 +00:00
dispLogo
2017-12-29 10:46:53 +00:00
2018-03-22 10:14:26 +00:00
# show system informations
dispSysInfos
2017-12-27 13:54:15 +00:00
2017-12-28 18:27:44 +00:00
# Useless by itself, but is used to don't be annoyed later in the script
2017-12-27 13:54:15 +00:00
sudo echo
2018-03-14 18:39:12 +00:00
# init, check and install/update dependencies
2018-03-14 18:34:00 +00:00
yggInit
2017-12-27 13:54:15 +00:00
pressKey
# Apps dir created if necessary
mkdir -p /home/$myHomedir/Apps
2017-12-30 22:08:45 +00:00
#-----------------------------------------------------------------------------#
# Main menu #
#-----------------------------------------------------------------------------#
2017-12-27 13:54:15 +00:00
while true; do # main menu loop
mainMenuOptions=$(whiptail \
--title "Yggdrasil $version - Main Menu" \
--menu "This tool will help you to install all needed applications and cutomize your fresh install of Mint/Ubuntu/Elementary/..." \
25 80 16 \
"1" "System update" \
"2" "Add required PPA/Repo" \
"3" "Applications" \
"4" "Applications (BETA)" \
"5" "Applications (Nightly)" \
"6" "Themes & Icons" \
"7" "Dev Apps" \
"8" "System Config" \
"9" "System Tools" \
"10" "Reboot this computer" \
"11" "About Yggdrasil" \
"12" "Quit" 3>&1 1>&2 2>&3)
case $mainMenuOptions in
"1")
updateSystem
pressKey
;;
"2")
addRequiredPPA
pressKey
;;
"3")
showAppInstallMenu
;;
"4")
showAppBetaInstallMenu
;;
"5")
showAppNightlyInstallMenu
;;
"6")
showThemesInstallMenu
;;
"7")
showDevInstallMenu
;;
"8")
showConfigMenu;
;;
"9")
showSysToolsMenu
;;
"10")
showRebootBoxMenu
;;
"11")
showAboutBoxMenu
;;
"12")
exit
;;
esac # main menu
done # end of main menu loop
clear
2017-12-30 22:08:45 +00:00
exit